Core Resources
Charge activitiesNew
A charge activity is a record of something that happened to a
Charge, such as a payment attempt, a payment failure, a skip, a reschedule or a refund. Charge activities give a timeline of a Charge together with a description of each event and, for failures, a suggested solution. Only charge activities created in the last 90 days are available.This resource is new in the V2 reference. It also works when you send X-Recharge-Version: 2021-11.
#The charge activity object
Attributes
- idintegerThe unique numeric identifier for the charge activity.
- activity_detailsobjectAn object containing additional details about the event. Its contents depend on the
activity_typeandactivity_sub_type.Show child attributesHide child attributes3
- descriptionstringA human-readable description of the event.
- suggested_solutionstringA suggested way to resolve the issue, when the event is a failure. An empty string when there is no suggestion.
- linksobjectAn object containing links to help articles referenced by
descriptionandsuggested_solution.
- activity_sub_typestringA more specific classification of the event within its
activity_type, such ascard_declinedfor apayment_failure. Can be an empty string. - activity_typestringThe type of event that was recorded, such as
payment_success,payment_failure,skipped,rescheduledorrefund_success. - address_idintegerThe ID of the
Addressof theCharge. - charge_amountfloatThe amount of the
Chargeat the time of the event. - charge_idintegerThe ID of the
Chargethe activity belongs to. - includeobjectAn object containing the related resources requested with the
includequery parameter.Only returned when theincludequery parameter is passed.Show child attributesHide child attributes2
- payment_methodsarrayAn array of
PaymentMethodsassociated with theChargeof the activity.Only returned whenincludecontainspayment_methods. - chargeobjectThe
Chargethe activity belongs to.Only returned whenincludecontainscharge.
- updated_atdatetimeThe date and time when the charge activity was last updated.
- created_atdatetimeThe date and time when the charge activity was created.
- customer_idintegerThe ID of the
CustomertheChargebelongs to. - external_payment_method_idstring · nullableThe ID of the payment method as it appears in the payment processor system.
- order_idinteger · nullableThe ID of the
Orderassociated with the activity, if any. - payment_method_idinteger · nullableThe ID of the
PaymentMethodused for the activity, if any. - payment_methods_infoarray of objectsAn array describing the payment methods in use when the event was recorded.
Show child attributesHide child attributes7
- payment_method_idintegerThe ID of the
PaymentMethod. - payment_typestringThe type of the payment method, such as
CREDIT_CARDorPAYPAL. - brandstring · nullableThe brand of the card.Only returned for card-based payment types.
- last4string · nullableThe last four digits of the card or bank account.Only returned for card-based and SEPA debit payment types.
- exp_monthinteger · nullableThe expiration month of the card.Only returned for card-based payment types.
- exp_yearinteger · nullableThe expiration year of the card.Only returned for card-based payment types.
- paypal_emailstring · nullableThe email address of the PayPal account.Only returned for PayPal payment methods.
- store_idintegerThe ID of the store the charge activity belongs to.
{
"charge_activity": {
"id": 987654321,
"address_id": 21317826,
"charge_id": 100714428,
"customer_id": 12345,
"order_id": null,
"payment_method_id": 55501,
"store_id": 1234,
"activity_details": {
"charge_attempts": 1,
"description": "Charge was successfully paid.",
"links": {},
"payment_gateway": "stripe",
"payment_transaction_id": "ch_XXXXXXXXXXXXXXX",
"presentment_currency": "USD",
"suggested_solution": ""
},
"activity_sub_type": "attempt_success",
"activity_type": "payment_success",
"charge_amount": 13.14,
"created_at": "2026-11-10T09:45:44+00:00",
"external_payment_method_id": "pm_XXXXXXXXXXXXXXX",
"payment_methods_info": [
{
"payment_method_id": 55501,
"payment_type": "CREDIT_CARD",
"brand": "visa",
"exp_month": 12,
"exp_year": 2030,
"last4": "4242"
}
],
"updated_at": "2026-11-10T09:45:44+00:00"
}
}#List charge activities
GET/charge_activities
Returns a list of charge activities created in the last 90 days. Either the
read_orders or the read_payment_methods scope is sufficient.Scopes
read_ordersread_payment_methodsQuery parameters
- idsstringFilter charge activities by a comma-separated list of IDs.
- charge_idintegerFilter charge activities by
Charge. - address_idintegerFilter charge activities by
Address. - payment_method_idintegerFilter charge activities by
PaymentMethod. - activity_typestringFilter charge activities by
activity_type, such aspayment_failure. - activity_sub_typestringFilter charge activities by
activity_sub_type, such ascard_declined. - created_at_minstringShow charge activities created after the given date. Must be within the last 90 days, which is also the default.
- created_at_maxstringShow charge activities created before the given date. Must be within the last 90 days and cannot be in the future.
- includestringA comma-separated list of related resources to return under the
includeattribute of each charge activity.payment_methodsrequires theread_payment_methodsscope andchargerequires theread_ordersscope.Possible valuespayment_methodscharge - sort_bystringSort listed charge activities in a specific order. Defaults to
id-desc.Possible valuesid-ascid-desc - limitintegerThe amount of results. The default is 50 and the maximum is 250.
- pageintegerThe page to show. Page-based pagination is deprecated; use
cursorinstead. - cursorstringThe
next_cursororprevious_cursorvalue returned by a previous call, used to retrieve the next or previous page of results. When passed, the only other parameter that can be passed islimit.
curl 'https://api.rechargeapps.com/charge_activities' \
-H 'X-Recharge-Version: v2' \
-H 'X-Recharge-Access-Token: your_api_token'{
"next_cursor": null,
"previous_cursor": null,
"charge_activities": [
{
"id": 987654321,
"address_id": 21317826,
"charge_id": 100714428,
"customer_id": 12345,
"order_id": null,
"payment_method_id": 55501,
"store_id": 1234,
"activity_details": {
"charge_attempts": 1,
"description": "Charge was successfully paid.",
"links": {},
"payment_gateway": "stripe",
"payment_transaction_id": "ch_XXXXXXXXXXXXXXX",
"presentment_currency": "USD",
"suggested_solution": ""
},
"activity_sub_type": "attempt_success",
"activity_type": "payment_success",
"charge_amount": 13.14,
"created_at": "2026-11-10T09:45:44+00:00",
"external_payment_method_id": "pm_XXXXXXXXXXXXXXX",
"payment_methods_info": [
{
"payment_method_id": 55501,
"payment_type": "CREDIT_CARD",
"brand": "visa",
"exp_month": 12,
"exp_year": 2030,
"last4": "4242"
}
],
"updated_at": "2026-11-10T09:45:44+00:00"
}
]
}